config/routes.rb
# encoding: UTF-8

# Routes
Rails.application.routes.draw do
  # Bookings
  resources :bookings do
    collection do
      post :select
    end
    member do
      get :select_booking
      get :copy
    end
  end

  resources :accounts do
    member do
      get :csv_bookings
      get :edit_bookings
      post :update_bookings
    end
    resources :bookings
    resources :attachments
  end

  resources :banks do
    resources :phone_numbers
    member do
      get :new_phone_number
    end
    collection do
      get :new_phone_number
    end
  end

  resources :bank_accounts do
    member do
      get :csv_bookings
    end
    resources :bookings
    resources :attachments
  end

  resources :booking_templates do
    member do
      get :new_booking
    end
  end
end

app/controllers/bookings_controller.rb
class BookingsController < HasAccountsController
  # Scopes
  has_scope :by_code
  has_scope :by_text
  has_scope :by_amount, :using => [:from, :to]
  has_scope :by_date, :using => [:from, :to]

  # Actions
  def select_booking
    @booking = Booking.find(params[:id]).dup

    # Clear reference
    @booking.reference  = nil

    increment_booking_code
    # Take value date from form
    @booking.value_date = params[:booking][:value_date]

    render :action => 'edit'
  end

  def select
    @booking = Booking.new(params[:booking])
    increment_booking_code
    @booking_templates = BookingTemplate.where(:type => [nil, 'BookingTemplate']).where("NOT(code LIKE '%:%')").paginate(:page => params[:page])
    @bookings = Booking.where("title LIKE ?", '%' + @booking.title + '%').order('value_date DESC').paginate(:page => params[:page])
  end

  def create
    create! { new_booking_path }
  end

  def copy
    original_booking = Booking.find(params[:id])

    @booking = original_booking.dup

    render 'edit'
  end

  private

  def increment_booking_code
    @booking.code = (Booking.maximum(:code) || 0) + 1
  end
end

app/views/bookings/_booking.html.haml
- item_action ||= lambda{|object| url_for(object)}

%tr[booking]
  %td= booking.value_date
  %td= booking.code
  %td.subject
    = link_to booking.title, item_action.call(booking), 'data-table-key' => '13'
    - if booking.comments.present?
      %div
        %i= booking.comments
  %td= link_to booking.reference.to_s(:reference), booking.reference unless booking.reference.nil?
  %td= link_to booking.debit_account.code, account_path(booking.debit_account), :title => booking.debit_account.title unless booking.debit_account.nil?
  %td= link_to booking.credit_account.code, account_path(booking.credit_account), :title => booking.credit_account.title unless booking.credit_account.nil?
  %td.currency= currency_fmt(booking.amount)
  %td.action-links
    = list_link_for(:edit, booking, 'data-table-key' => '69')
    = list_link_for(:delete, booking, :remote => true, 'data-table-key' => '68')
    = list_link_for(:copy, booking, 'data-table-key' => '67')

app/views/bookings/_booking_form.html.haml
- booking = resource
%tr[booking]
  = simple_fields_for booking, :wrapper => 'table' do |f|
    %td= f.input :value_date, :as => 'date_field', :label => false
    %td= f.input :code, :label => false
    %td
      = f.input :title, :input_html => {'data-autofocus' => true}
      = f.input :comments, :rows => 2
    %td= link_to booking.reference.to_s(:reference), booking.reference unless booking.reference.nil?
    %td= f.association :debit_account, :collection => accounts_as_collection(Account.all), :as => :combobox, :input_html => { :style => 'max-width: 14ex' }
    %td= f.association :credit_account, :collection => accounts_as_collection(Account.all), :as => :combobox, :input_html => { :style => 'max-width: 14ex' }
    %td= f.input :amount, :as => :string
    %td.action-links
      = list_link_for(:show, booking, :icon => 'remove', :method => :put, :remote => true, 'data-table-key' => '27')
      = link_to "#", 'data-table-key' => '13' do
        %i.icon-ok

app/views/bookings/_filter_form.html.haml
= simple_form_for '', :method => :get, remote: true do |f|
  .container-fluid
    .row-fluid
      .span3= f.input :by_code, label: t_attr(:code), required: false
      .span6= f.input :by_text, label: t(:by_text, scope: 'bookings.search'), required: false
    .row-fluid
      .span3= f.input 'by_amount[from]', label: t(:by_amount_from, scope: 'bookings.search'), required: false
      .span3= f.input 'by_amount[to]', label: t(:by_amount_to, scope: 'bookings.search'), required: false
      .span3= f.input 'by_date[from]', label: t(:by_date_from, scope: 'bookings.search'), required: false, input_html: { value: try_parse_date(params[:by_date][:from]) }
      .span3= f.input 'by_date[to]', label: t(:by_date_to, scope: 'bookings.search'), required: false, input_html: { value: try_parse_date(params[:by_date][:to]) }

  .form-actions
    = f.button :submit, t_action(:search)

app/views/bookings/_form.html.haml
= simple_form_for resource do |f|
  = render 'form_fields', resource: resource, f: f

  .form-actions
    = f.button :submit, :value => 'Tạo Booking'

app/views/bookings/_form_fields.html.haml
.row-fluid
  .span6
    = f.input :title, :input_html => {"data-autofocus" => true}
  .span6
    = f.input :value_date, :as => :date_field
.row-fluid
  .span6
    = f.input :amount, :as => :string
  - if resource.respond_to? :code
    .span6
      = f.input :code

.row-fluid
  .span6
    = f.association :debit_account, :collection => accounts_as_collection(Account.all), :as => :combobox
  .span6
    = f.association :credit_account, :collection => accounts_as_collection(Account.all), :as => :combobox

.row-fluid
  .span6
    = f.input :reservationnumber

.row-fluid
  .span12
    = f.input :comments, :input_html => {:rows => 4, :class => 'span12'}

.row-fluid
  .span12
    = f.input :reference_type, :as => :hidden, :input_html => {:value => 'Invoice'}
    = f.association :reference, :collection => suggested_invoices_for_booking(resource, :include_all => true), :as => :combobox, :include_blank => true

app/views/bookings/_list.html.haml
= form_tag '', :id => 'bookings_table_form', 'data-table-select' => true, :method => :put, :remote => true do
  %table.table.table-striped.bookings.collection
    %thead
      %tr
        %th.valute_date= t_attr :valuta
        %th.code= t_attr :code
        %th.title= t_attr :title
        %th.reference= t_attr :reference
        %th.debit_account= t_attr :debit_account
        %th.credit_account= t_attr :credit_account
        %th.amount.currency= t_attr 'amount'
        %th.action-links(style='width: 66px')
    %tbody
      = render collection, :item_action => (item_action ||= nil)

= paginate collection if defined?(paginate)
= render 'bookings/sidebar'

app/views/bookings/_sidebar.html.haml
- filter_name = :by_date

app/views/bookings/index.html.haml
.contextual
  = icon_link_to :print, params.merge({:format => :pdf, :per_page => 5000, :page => 1})
  = contextual_links_for

= boot_page_title

= render 'filter_form'

.index
  = render 'list'

app/views/bookings/index.js.erb
$('.index').html('<%=escape_javascript render "list" %>');
initializeBehaviours();

app/views/bookings/select.html.haml
= contextual_links

= boot_page_title :new

= render 'form'

%h3= t_model(BookingTemplate)
= render 'booking_templates/list', :item_action => lambda{|object| new_booking_booking_template_path(object)}

%h3= t_model(Booking)
= render 'bookings/list', :item_action => lambda{|object| select_booking_booking_path(object, :booking => params[:booking])}

app/views/bookings/show.html.haml
.contextual
  = contextual_links_for
  = icon_link_to :copy

= boot_page_title

= render 'show'

app/views/bookings/show.js.erb
$('#booking_<%= resource.id %>').replaceWith('<%=j render "booking_form" %>');
$('#bookings_table_form').attr('action', '<%= booking_path(resource) %>');
initializeBehaviours();
window.bookyt_table.enterEdit()

app/views/bookings/update.js.erb
$('#<%= "#{resource.class.name.underscore}_#{resource.to_param}" %>').replaceWith('<%=escape_javascript render resource %>');
$('tr#<%= "#{resource.class.name.underscore}_#{resource.to_param}" %>').addClass('selected')
initializeBehaviours();